# API Maker v1.14.0 Release Notes

> What’s new in v1.14.0:- new capabilities, fixes, and developer experience updates.

Source: https://docs.apimaker.dev/v1/docs/blog/release-notes/v1.14.0.html

## April 2025

### Changes

- **[IMPROVEMENT] :** Prevent caching issue of UI after API Maker deployment.
- **[IMPROVEMENT] :** Progressbar implemented in deployment screen.
- **[BUG]** : $nin should not throw for null or empty string when userd with objectId field.
- **[BUG]** : Getting error after saving data in sql server when uniqueidentifier is used as primary key.
- **[IMPROVEMENT] :** Update & close button added in schema edit modal.
- **[IMPROVEMENT] :** Error cleanup for SQL server driver related errors.
- **[BUG] :** Date object in conversionFun is not working for SQL server save operation.
- **[IMPROVEMENT] :** D2 diagram library installation related improvements.
- **[BUG] :** When collection is not present and schema is present, it selects all items
- **[FEATURE] :** Added support for `isAutoGenerateByAM` in schema as shown below.

```typescript
import { ISchemaType, EType, ISchemaProperty, IPropertyValidation } from 'types';
import * as T from 'types';

let schema: ISchemaType = {
    _id: EType.objectId,
    name: EType.string,

    autoGenerateObjectId: {
        __type: EType.objectId,
        isAutoGenerateByAM: {
            valueGeneratorType: T.EValueGeneratorType.ObjectID,
        }
    },
    autoGenerate_GUID_UUID: {
        __type: EType.string,
        isAutoGenerateByAM: {
            valueGeneratorType: T.EValueGeneratorType.GUID_UUID,
        }
    },
    autoGenerate_ULID: {
        __type: EType.string,
        isAutoGenerateByAM: {
            valueGeneratorType: T.EValueGeneratorType.ULID,
        }
    },
    autoGenerate_ShortUUID: {
        __type: EType.string,
        isAutoGenerateByAM: {
            valueGeneratorType: T.EValueGeneratorType.ShortUUID,
        }
    }
};

module.exports = { schema };
```

### UI Maker Extension

- **[IMPROVEMENT] :** uim-grid-header class added for header.
- **[FEATURE] :** editor control support added.
- **[FEATURE] :** Required should support expression in UI Maker by providing requiredFun in validations.
- **[IMPROVEMENT] :** Below two functions support added in utils object.
    - setDataInObject
    - setDataInArray

        ```typescript
        /** Useful to clear all properties of object and assign all properties of new object */
        setDataInObject(oldObject: any, newObject: any): void;

        /** Useful to clear all properties of object and assign all properties of new object */
        setDataInArray(oldArray: any[], newArray: any[]): void;
        ```

- **[IMPROVEMENT] :** DB Master page load performance improvements.
- **[IMPROVEMENT] :** If we pass query parameter in iframe URL with name `id` and with value, UI Maker will open modal with that ID in edit mode by default. To open in view mode we can pass `form-open-mode=view` also.
- **[FEATURE] :** UI Maker page can be used as only form also. Form can be used in add/edit/view modes.
- **[IMPROVEMENTS] :** Add | Edit | Delete | View | Refresh Grid operations support added in user utils functions.
- **[IMPROVEMENT] :** Added support for `onceGridDataLoaded` hook to process data once grid data loaded.
- **[FEATURE] :** On click of button, generate sample working code of grid & form fields JSON and put it in editor. This button is available in top right corner of UI Maker page modal.
- **[FEATURE] :** Add support for “uim” in schema, so we can generate code based on those settings also.
